Incremental HTTP Messages
Internet-Draft draft-kazuho-httpbis-incremental-http-00
奥 一穂
Fastly
kazuhooku@gmail.com
Tommy Pauly
Apple
tpauly@apple.com
Martin Thomson
Mozilla
mt@lowentropy.net
15 October 2024
httpbis
internet-draft
This document specifies the "Incremental" HTTP header field, which instructs HTTP intermediaries to forward the HTTP message incrementally.
Discussion Venues
Discussion of this document takes place on the HTTP Working Group mailing list (ietf-http-wg@w3.org), which is archived at https://lists.w3.org/Archives/Public/ietf-http-wg/.
Source for this draft and an issue tracker can be found at https://github.com/kazuho/draft-kazuho-httpbis-incremental-http.
Introduction
HTTP [HTTP] permits receivers to begin processing portions of HTTP messages as they arrive, rather than requiring them to wait for the entire HTTP message to be received before acting.
Some applications are specifically designed to take advantage of this capability.
For example, Server-Sent Events [SSE] uses a long-running HTTP response, where the server continually sends notifications as they become available.
In the case of Chunked Oblivious HTTP Messages [CHUNKED-OHTTP], the client opens an HTTP request and incrementally sends application messages, while the server can start responding even before the HTTP request is fully complete. In this way, the HTTP request-response pair effectively serves as a bi-directional communication channel.
However, these applications are fragile when HTTP intermediaries are involved. This is because HTTP intermediaries are not only permitted but are frequently deployed to buffer complete HTTP messages before forwarding them downstream (Section 7.6 of [HTTP]).
If such a buffering HTTP intermediary exists between the client and the server, these applications may fail to function as intended.
In the case of Server-Sent Events, when an intermediary tries to buffer the HTTP response completely before forwarding it, the client might time out before receiving any portion of the HTTP response.
In the case of Chunked Oblivious HTTP Messages, when an intermediary tries to buffer the entire HTTP request, the client will not start receiving application messages from the server until the client closes the request, effectively disrupting the intended incremental processing of the request.
To help avoid such behavior, this document specifies the "Incremental" HTTP header field, which instructs HTTP intermediaries to begin forwarding the HTTP message downstream before receiving the complete message.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The term Boolean is imported from [STRUCTURED-FIELDS].
The Incremental Header Field
The Incremental HTTP header field expresses the sender's intent for HTTP intermediaries to start forwarding the message downstream before the entire message is received.
This header field has just one valid value of type Boolean: "?1".

Incremental = ?1

Upon receiving a header section that includes the Incremental header field, HTTP intermediaries SHOULD NOT buffer the entire message before forwarding it. Instead, intermediaries SHOULD transmit the header section downstream and continuously forward the bytes of the message body as they arrive.
The Incremental HTTP header field applies to each HTTP message. Therefore, if both the HTTP request and response need to be forwarded incrementally, the Incremental HTTP header field MUST be set for both the HTTP request and the response.
The Incremental field is advisory. Intermediaries that are unaware of the field or that do not support the field might buffer messages, even when explicitly requested otherwise. Clients and servers therefore cannot expect all intermediaries to understand and respect a request to deliver messages incrementally. Clients can rely on prior knowledge or probe for support on individual resources.
Security Considerations
Applying Concurrency Limits
To conserve resources required to handle HTTP requests or connections, it is common for intermediaries to impose limits on the maximum number of concurrent HTTP requests that they forward, while buffering requests that exceed this limit.
Such intermediaries could apply a more restrictive concurrency limit to requests marked as incremental to ensure that capacity remains available for non-incremental requests, even when the maximum number of incremental requests is reached. This approach helps balance the processing of different types of requests and maintains service availability across all requests.
When rejecting incremental requests due to reaching the concurrency limit, intermediaries SHOULD respond with a 503 Service Unavailable error, accompanied by a connection_limit_reached Proxy-Status response header field (Section 2.3.12 of [PROXY-STATUS]).
IANA Considerations
TBD
References
Normative References
[HTTP]

HTTP Semantics
R. Fielding, Ed.
M. Nottingham, Ed.
J. Reschke, Ed.
June 2022
STD 97
RFC 9110
DOI 10.17487/RFC9110
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[STRUCTURED-FIELDS]

Structured Field Values for HTTP
M. Nottingham
P-H. Kamp
February 2021
RFC 8941
DOI 10.17487/RFC8941
Informative References
[PROXY-STATUS]

The Proxy-Status HTTP Response Header Field
M. Nottingham
P. Sikora
June 2022
RFC 9209
DOI 10.17487/RFC9209
[SSE]

Server-Sent Events
WHATWG
n.d.
[CHUNKED-OHTTP]

Chunked Oblivious HTTP Messages
Tommy Pauly
Apple
Martin Thomson
Mozilla
8 July 2024
Internet-Draft draft-ietf-ohai-chunked-ohttp-01
Acknowledgments
TODO acknowledge.